package index.alg;

import index.entity.BoxEdge;
import index.entity.Point;
import index.entity.WholeIndex;

import java.util.ArrayList;

public class BoxCorTrans {

    WholeIndex wholeIndex;

    public BoxCorTrans(WholeIndex wholeIndex){

        this.wholeIndex = wholeIndex;

    }

    public Point pointTrans(Point pointForTrans){

        Double xFt = pointForTrans.getColX();
        Double yFt = pointForTrans.getColY();

        Double xAt = xFt * wholeIndex.getxGap() + wholeIndex.getMinX();
        Double yAt = yFt * wholeIndex.getyGap() + wholeIndex.getMinY();

        Point pointAfterTrans = new Point();

        pointAfterTrans.setColX(xAt);
        pointAfterTrans.setColY(yAt);

        return pointAfterTrans;

    }

    public ArrayList<Point> pointArrayListTrans(ArrayList<Point> pointArrayListForTrans){

        ArrayList<Point> pointArrayListAfterTrans = new ArrayList<>();

        for (int i = 0 ; i < pointArrayListForTrans.size();i++){

            Point point = pointArrayListForTrans.get(i);
            Point pointAt = pointTrans(point);
            pointArrayListAfterTrans.add(pointAt);

        }
        return pointArrayListAfterTrans;
    }

    public BoxEdge boxEdgeTrans(BoxEdge boxEdgeForTrans){

        BoxEdge boxEdgeAfterTrans = new BoxEdge();
        Point point1 = boxEdgeForTrans.getPoint1();
        Point point2 = boxEdgeForTrans.getPoint2();

        point1 = pointTrans(point1);
        point2 = pointTrans(point2);

        boxEdgeAfterTrans.setPoint1(point1);
        boxEdgeAfterTrans.setPoint2(point2);

        return boxEdgeAfterTrans;

    }

    public ArrayList<BoxEdge> boxEdgeArrayListTrans(ArrayList<BoxEdge> boxEdgeArrayListForTrans){

        ArrayList<BoxEdge> boxEdgeArrayListAfterTrans = new ArrayList<>();
        for (int i = 0 ; i < boxEdgeArrayListForTrans.size();i++){

            BoxEdge boxEdge = boxEdgeArrayListForTrans.get(i);
            boxEdge = boxEdgeTrans(boxEdge);
            boxEdgeArrayListAfterTrans.add(boxEdge);

        }

        return boxEdgeArrayListAfterTrans;

    }



}
