package index.alg;

import index.alg.boxscan.ScanOutLine;
import index.entity.*;
import index.log.Log;
import index.plot.Plot;

import java.util.ArrayList;

public class BoxFlow {

    public void start(ArrayList<Point> initialPoints,ArrayList<Point> allWorkPoints) throws Exception {

        Plot plot = new Plot("/Users/haoqianpan/file/programfile/meanshift/out/boxscan/");

        plot.collectData("initial.txt",initialPoints);

        //计算分割网格的一些参数
        BuildInitialWholeIndex buildInitialWholeIndex = new BuildInitialWholeIndex();
        WholeIndex wholeIndex = buildInitialWholeIndex.build(initialPoints,100,100);

        Log.print("已分割");

        //获取直线
        BuildLines buildLines = new BuildLines();
        ArrayList<LineSegment> lineSegments = buildLines.build(initialPoints);

        Log.print("已获取直线");

        //计算初始形状的占用情况
        BuildInitialOccupy buildInitialOccupy = new BuildInitialOccupy();
        OccupyPoint occupyPoint = buildInitialOccupy.build(lineSegments,wholeIndex);

        Log.print("初始占用情况已计算");

        //过滤掉太远的作业点
        WorkPointsExclude workPointsExclude = new WorkPointsExclude();
        ArrayList<Point> pointsExclude = workPointsExclude.pointsExclude(allWorkPoints,wholeIndex);

        Log.print("作业点已过滤");

        plot.collectData("pointsexclude.txt",pointsExclude);

        //作业点填充
        FillWorkPoints fillWorkPoints = new FillWorkPoints();
        ArrayList<ArrayList<Integer>> indexsList = fillWorkPoints.Fill(wholeIndex,pointsExclude);

        Log.print("作业点已填充");

        //计算作业后的占用情况
        BuildChangedOccupy buildChangedOccupy = new BuildChangedOccupy();
        buildChangedOccupy.build(occupyPoint,wholeIndex,indexsList);

        Log.print("作业后占用情况已计算");

        //构造box
        BuildBoxFromList buildBoxFromList = new BuildBoxFromList();
        ArrayList<Box> boxArrayList = buildBoxFromList.build(wholeIndex,indexsList);

        Log.print("已构造box");

        //扫描

        Log.print("开始扫描");

        ScanOutLine scanOutLine = new ScanOutLine();
        scanOutLine.scan(boxArrayList,100);
        ArrayList<ArrayList<BoxEdge>> shapeList = scanOutLine.getShapeList();
        ArrayList<ArrayList<Point>> shapePointList = scanOutLine.getShapePointList();


        Log.print("扫描结束");


        BoxCorTrans boxCorTrans = new BoxCorTrans(wholeIndex);


        //中点
        ArrayList<ArrayList<Point>> pointsArrayList = new ArrayList<>();

        //取边的中点相连
        for (int i = 0 ; i < shapeList.size();i++){

            ArrayList<Point> points = new ArrayList<>();
            ArrayList<BoxEdge> boxEdges = shapeList.get(i);
            for (int j = 0 ; j < boxEdges.size();j++){

                BoxEdge boxEdge = boxEdges.get(j);
                Point pointMiddle = boxEdge.getMiddlePoint();
                points.add(pointMiddle);

            }

            points = boxCorTrans.pointArrayListTrans(points);
            points.add(points.get(0));
            plot.collectData("shapemiddle-" + i,points);
            pointsArrayList.add(points);

        }

//        for (int i = 0 ; i < pointsArrayList.size();i++){
//
//            ArrayList<Point> points = shapePointList.get(i);
//            points.add(points.get(0));
//            points = boxCorTrans.pointArrayListTrans(points);
//            System.out.println(points.size());
//            plot.collectData("shape-" + i,points);
//
//        }

        //网格端点直连
        for (int i = 0 ; i < shapePointList.size();i++){

            ArrayList<Point> points = shapePointList.get(i);
            points.add(points.get(0));
            points = boxCorTrans.pointArrayListTrans(points);
            System.out.println(points.size());
            plot.collectData("shape-" + i,points);
        }

        plot.normalPrint();

    }

}
