package index.alg;

import index.entity.Point;

import java.util.ArrayList;

public class CurveTool {


    public ArrayList<Double> calLineabc(Point point1, Point point2){

        Double x1 = point1.getColX();
        Double y1 = point1.getColY();
        Double x2 = point2.getColX();
        Double y2 = point2.getColY();


        //////////
        Double lineA;
        Double lineB;
        Double lineC;
        ArrayList<Double> lineParamList = new ArrayList<>();

        /////////

        if (! x1.equals(x2)){

            lineA = (y1 - y2) / (x1 - x2);
            lineB = -1.0;
            lineC = y1 - lineA * x1;
            lineParamList.add(lineA);
            lineParamList.add(lineB);
            lineParamList.add(lineC);
        }

        return  lineParamList;
    }

    public Double distanceFromPointToLine(ArrayList<Double> lineParamList,Point point){

        Double x = point.getColX();
        Double y = point.getColY();

        Double lineA = lineParamList.get(0);
        Double lineB = lineParamList.get(1);
        Double lineC = lineParamList.get(2);


        Double value1 = lineA * x + lineB * y + lineC;
        Double value2 = Math.sqrt(Math.pow(lineA,2) + Math.pow(lineB,2));
        Double dis = Math.abs(value1 / value2);

        return dis;
    }

    public Double getLineYValue(Double x,ArrayList<Double> lineParamList){

        Double lineA = lineParamList.get(0);
        Double lineC = lineParamList.get(2);

//        System.out.println();

        Double y = lineA * x + lineC;
        return y;

    }

    //多阶
    public Double getCurveValue(Double x,double[] curveParamList){

        Integer degree = curveParamList.length;
        Double y = 0.0;
        for (int i = 0 ;i < degree;i++){
            Double param = curveParamList[i];
            y = y + Math.pow(x,i) * param;
        }
        return y;
    }
    
}
