package index.alg;

import index.entity.Index;
import index.entity.Point;
import index.entity.WholeIndex;

import java.util.ArrayList;

public class FillWorkPoints {

    Integer workNumber = 0;
    Integer occupyNumber = 1;
    Integer otherNumber = 3;

    //填充
    public ArrayList<ArrayList<Integer>> Fill(WholeIndex wholeIndex,ArrayList<Point> pointsExclude){

        //占用情况，作业点经过的地方是0，未经过是3
        ArrayList<ArrayList<Integer>> indexsList = new ArrayList<>();

        //网格划分的情况
        Double minX = wholeIndex.getMinX();
        Double minY = wholeIndex.getMinY();
        Integer numOfGapsX = wholeIndex.getNumOfGapsX();
        Integer numOfGapsY = wholeIndex.getNumOfGapsY();
        Double xGap =wholeIndex.getxGap();
        Double yGap = wholeIndex.getyGap();

        //赋初值
        indexsList = indexsListInitial(indexsList,numOfGapsX,numOfGapsY);


        IndexTool indexTool = new IndexTool(wholeIndex);
        //判断占用情况，
        for (int i = 0 ; i < pointsExclude.size() ;i++){
            Point pointWork = pointsExclude.get(i);
            Index indexWork = indexTool.identifyIndex(pointWork);
            setIndexValue(indexWork,indexsList,workNumber);
        }


        //纵向填充
        for (int i = 0 ; i < indexsList.size();i++){

            ArrayList<Integer> indexsForFill = indexsList.get(i);
            fillList(indexsForFill,workNumber,5);
            indexsList.set(i,indexsForFill);
        }

        //换个方向填充
        indexsList = changedDirect(indexsList);

        for (int i = 0 ; i < indexsList.size();i++){

            ArrayList<Integer> indexsForFill = indexsList.get(i);
            fillList(indexsForFill,workNumber,5);
            indexsList.set(i,indexsForFill);
        }

        //再转回来
        indexsList = changedDirect(indexsList);

        return indexsList;


    }

    public void setIndexValue(Index indexWork,ArrayList<ArrayList<Integer>> indexsList,Integer value){

        Integer xIndex = indexWork.getxIndex();
        Integer yIndex = indexWork.getyIndex();

        ArrayList<Integer> indexsForRevise = indexsList.get(xIndex);
        indexsForRevise.set(yIndex,value);
        indexsList.set(xIndex,indexsForRevise);

    }

    public ArrayList<ArrayList<Integer>> changedDirect(ArrayList<ArrayList<Integer>> indexsList){

        Integer xSize = indexsList.size();
        ArrayList<Integer> indexs0  = indexsList.get(0);
        Integer ySize = indexs0.size();

        ArrayList<ArrayList<Integer>> indexsListAfterChanged = new ArrayList<>();

        for (int i = 0 ; i < ySize;i++){


            ArrayList<Integer> changed = new ArrayList<>();
            for (int j = 0 ; j < xSize ;j++){

                ArrayList<Integer> row = indexsList.get(j);
                changed.add(row.get(i));
            }

            indexsListAfterChanged.add(changed);

        }

        return indexsListAfterChanged;




    }

    public ArrayList<ArrayList<Integer>> indexsListInitial(ArrayList<ArrayList<Integer>> indexsList,Integer numOfGapsX,Integer numberOfGapsY){

        for (int i = 0 ; i < numOfGapsX;i++){

            ArrayList<Integer> indexs = new ArrayList<>();
            for (int j = 0 ; j < numberOfGapsY;j++){

                indexs.add(otherNumber);

            }
            indexsList.add(indexs);

        }

        return indexsList;

    }


    //当间隙小于scale时就填充
    public void fillList( ArrayList<Integer> indexsForFill,Integer characterValue,Integer scale){


        //当前列，被占据的网格的编号（纵向编号）
        ArrayList<Integer> hasCharaIndexList = new ArrayList<>();

         for (int i = 0 ; i < indexsForFill.size();i++){

             if (indexsForFill.get(i).equals(characterValue)){

                hasCharaIndexList.add(i);

             }

         }

         for (int i = 0 ; i < hasCharaIndexList.size() - 1;i++){

             Integer thisIndex = hasCharaIndexList.get(i);
             Integer nextIndex = hasCharaIndexList.get(i + 1);

             if (((nextIndex - thisIndex) < scale) &&((nextIndex - thisIndex) != 1)){

                 for (int j = (thisIndex + 1) ; j < nextIndex ; j++){

                     //填充
                     indexsForFill.set(j,characterValue);

                 }

             }

         }

    }



}
