package index.alg;

import index.entity.Index;
import index.entity.Point;
import index.entity.WholeIndex;

public class IndexTool {

    Double minX;
    Double minY;
    Integer numOfGapsX;
    Integer numOfGapsY;
    Double xGap;
    Double yGap;


    public IndexTool(WholeIndex wholeIndex){

        this.minX = wholeIndex.getMinX();
        this.minY = wholeIndex.getMinY();
        this.numOfGapsX = wholeIndex.getNumOfGapsX();
        this.numOfGapsY = wholeIndex.getNumOfGapsY();
        this.xGap =wholeIndex.getxGap();
        this.yGap = wholeIndex.getyGap();

    }


    public Index identifyIndex(Point point){

        Double pointX = point.getColX();
        Double pointY = point.getColY();


        Double xIndexTemp = (pointX - minX) / xGap;
        Double yIndexTemp = (pointY - minY) / yGap;

        Integer xIndex = xIndexTemp.intValue();
        Integer yIndex = yIndexTemp.intValue();
        Index index = new Index();

//        if (xIndex == numOfGapsX){
//
//            xIndex = xIndex -1;
//
//        }
//
//        if (yIndex == numOfGapsY){
//
//            yIndex = yIndex -1;
//
//        }

        if (xIndex >= numOfGapsX){

            xIndex = numOfGapsX -1;

        }

        if (yIndex >= numOfGapsY){

            yIndex = numOfGapsY -1;

        }



        index.setxIndex(xIndex);
        index.setyIndex(yIndex);

        return index;

    }

    public  Integer identifyYIndex(Double yCor){


        Double yIndexTemp = (yCor - minY)/yGap;
        Integer yIndex = yIndexTemp.intValue();

        if (yIndex >= numOfGapsY){

            yIndex = numOfGapsY - 1;

        }


        return yIndex;


    }

    public  Integer identifyXIndex(Double xCor){


//        Double xMin = xIndexCorList.get(0);
        Double xIndexTemp = (xCor - minX)/xGap;
        Integer xIndex = xIndexTemp.intValue();

        if (xIndex >= numOfGapsX){

            xIndex = numOfGapsX - 1;

        }

        return xIndex;


    }

}
