package index.alg;

import index.entity.Index;
import index.entity.OccupyPerX;
import index.entity.Point;
import index.entity.WholeIndexOccupy;
import index.file.OperateFile;

import java.io.FileNotFoundException;
import java.util.ArrayList;

public class Split {

    ArrayList<Double> xIndexCorList = new ArrayList<>();//格点横坐标List
    ArrayList<Double> yIndexCorList = new ArrayList<>();//格点纵坐标List

    public int numOfGaps = 100;

    CurveTool tool = new CurveTool();

    WholeIndexOccupy wholeIndexOccupy = new WholeIndexOccupy(numOfGaps);//初始网格占用情况

    public double xGap;

    public double yGap;


    //输入垛位的初始实际形状，形成网格
    public void cal(ArrayList<Point> pointsList) throws FileNotFoundException {

        OperateFile operateFile = new OperateFile();


        operateFile.printPoint("/Users/haoqianpan/file/programfile/meanshift/out/initial.txt",pointsList);
        pointsList.add(pointsList.get(0));



        Point point0 = pointsList.get(0);

        double minX = point0.getColX();

        double minY = point0.getColY();

        double maxX = point0.getColX();

        double maxY = point0.getColY();

        for (int i = 0 ; i < pointsList.size();i++){

            Point point = pointsList.get(i);

            double corX = point.getColX();

            double corY = point.getColY();

            if (corX < minX){

                minX = corX;

            }

            if (corX > maxX){

                maxX = corX;

            }

            if (corY < minY){

                minY = corY;

            }

            if (corY > maxY){

                maxY = corY;

            }

        }


        Point pointA = new Point();
        Point pointB = new Point();
        Point pointC = new Point();
        Point pointD = new Point();

        System.out.println("maxX " + maxX);
        System.out.println("minX " + minX);
        System.out.println("maxY " + maxY);
        System.out.println("minY " + minY);

        pointA.setColX(minX);
        pointA.setColY(minY);

        pointB.setColX(minX);
        pointB.setColY(maxY);

        pointC.setColX(maxX);
        pointC.setColY(maxY);

        pointD.setColX(maxX);
        pointD.setColY(minY);

        ArrayList<Point> rectanglePoints = new ArrayList<>();
        rectanglePoints.add(pointA);
        rectanglePoints.add(pointB);
        rectanglePoints.add(pointC);
        rectanglePoints.add(pointD);


        decideIndex(rectanglePoints);
        getLines(pointsList);

    }

    //横向纵向划分网格
    public void decideIndex(ArrayList<Point> fourPointsList){

        Point pointA = fourPointsList.get(0);
        Point pointB = fourPointsList.get(1);
        Point pointC = fourPointsList.get(2);
        Point pointD = fourPointsList.get(3);

        double distanceAB = calculateDistance(pointA,pointB);//纵向间距
        double distanceBC = calculateDistance(pointB,pointC);//横向间距

        double minX = pointA.getColX();
        double minY = pointA.getColY();
        double maxX = pointC.getColX();
        double maxY = pointC.getColY();

        xGap = (maxX - minX) / numOfGaps;
        System.out.println("xGap is : " + xGap);
        yGap = (maxY - minY) / numOfGaps;
        System.out.println("yGap is : " + yGap);


        for (int i = 0 ; i < numOfGaps + 1; i++){

            xIndexCorList.add(minX);
            minX = minX + xGap;
            yIndexCorList.add(minY);
            minY = minY + yGap;
        }

    }

    public double  calculateDistance(Point point1,Point point2){

        double corX1 = point1.getColX();
        double corY1 = point1.getColY();
        double corX2 = point2.getColX();
        double corY2 = point2.getColY();

        double distance = Math.sqrt(Math.pow((corX1 - corX2),2) + Math.pow((corY1 - corY2),2));
        return distance;

    }

    //根据实际形状的各个点形成直线
    public  ArrayList<ArrayList<Double>> getLines(ArrayList<Point> pointsList){

        ArrayList<ArrayList<Double>> linesParamList = new ArrayList<>();

        for (int i = 0 ; i < (pointsList.size() - 1);i++){

            //两个点形成直线
            Point pointI = pointsList.get(i);
            Point pointJ = pointsList.get(i + 1);
            boolean isTest = false;

            //直线一般式相关的参数，A,B,C
            ArrayList<Double> lineParamList  = tool.calLineabc(pointI,pointJ);
            linesParamList.add(lineParamList);
            lineOccupy(pointI,pointJ,lineParamList,isTest);

        }

        return linesParamList;





    }

    //计算直线在各个网格内的占据情况
    public void lineOccupy(Point pointI,Point pointJ,ArrayList<Double> lineParamList,Boolean isTest){

        Double xMin = xIndexCorList.get(0);
        Double yMin = yIndexCorList.get(0);
        ///
        //该直线起始点的网格位置
        Index indexI = identifyIndex(pointI);
        Index indexJ = identifyIndex(pointJ);

        //
        Integer xIndexBegin = indexI.getxIndex();//网格横向起始编号
        Integer yIndexBegin = indexI.getyIndex();//网格纵向起始编号

        Integer xIndexEnd = indexJ.getxIndex();//网格横向终止编号
        Integer yIndexEnd = indexJ.getyIndex();//网格纵向终止编号

        Integer lineYIndexMax = Math.max(yIndexBegin,yIndexEnd);
        Integer lineYIndexMin = Math.min(yIndexBegin,yIndexEnd);


        Integer lineXIndexMax = Math.max(xIndexBegin,xIndexEnd);
        Integer lineXIndexMin = Math.min(xIndexBegin,xIndexEnd);


        //
        if (xIndexBegin > xIndexEnd){

            Integer temp;
            temp = xIndexBegin;
            xIndexBegin = xIndexEnd;
            xIndexEnd = temp;

        }

//        if (isTest){
//
//            System.out.println("ISTEST起始横向网格" + xIndexBegin);
//            System.out.println("ISTEST终止横向网格" + xIndexEnd);
//            System.out.println("ISTEST起始纵向网格" + lineYIndexMin);
//            System.out.println("ISTEST终止纵向网格" + lineYIndexMax);
//            System.out.println("直线参数为：" + lineParamList);
//
//            ///测试直线
//            Double xTest = pointI.getColX();
//            Double yTest = pointI.getColY();
//            Double yTestResult = tool.getLineYValue(xTest,lineParamList);
//            System.out.println("xtest:" + xTest);
//            System.out.println("ytest:" + yTest);
//            System.out.println("ytestresult:" + yTestResult);
//
//        }



        //对该格点跨越的所有横向网格序号作循环
        for (int i = xIndexBegin;i < xIndexEnd + 1; i++){

            if (i == 100){
                System.out.println(xIndexBegin);
                System.out.println(xIndexEnd);
                System.out.println(pointJ.getColX());
            }
            //计算该直线（线段）在当前横向的网格内，在纵向的占据情况
            Integer minYIndex;
            Integer maxYIndex;
            Double xInputBegin;//网格的起始的横坐标
            Double xInputEnd;//
            Double yOutBegin;//
            Double yOutEnd;//






            xInputBegin = xMin + xGap * i;//当前网格的起始横坐标
            xInputEnd = xInputBegin + xGap;//当前网格的终止横坐标





            OccupyPerX occupyPerX =  new OccupyPerX();



            if ((lineParamList.size()!=0) && !(Double.POSITIVE_INFINITY == lineParamList.get(0) || Double.NEGATIVE_INFINITY == lineParamList.get(0))){

                yOutBegin = tool.getLineYValue(xInputBegin,lineParamList);//当前网格的起始纵坐标

                yOutEnd = tool.getLineYValue(xInputEnd,lineParamList);//当前网格的终止纵坐标

                Integer yBeginIndex = identifyYIndex(yOutBegin);
                Integer yEndIndex = identifyYIndex(yOutEnd);


                yBeginIndex = Math.min(yBeginIndex,lineYIndexMax);
                yBeginIndex = Math.max(yBeginIndex,lineYIndexMin);
                yEndIndex = Math.min(yEndIndex,lineYIndexMax);
                yEndIndex = Math.max(yEndIndex,lineYIndexMin);


                Integer yIndexMax;
                Integer yIndexMin;

                if (yBeginIndex > yEndIndex){

                    yIndexMin = yEndIndex;
                    yIndexMax = yBeginIndex;

                }
                else {

                    yIndexMax = yEndIndex;
                    yIndexMin = yBeginIndex;

                }

                occupyPerX.setMaxYIndex(yIndexMax);
                occupyPerX.setMinYIndex(yIndexMin);

            }

            else {

                occupyPerX.setMaxYIndex(Math.max(yIndexBegin,yIndexEnd));
                occupyPerX.setMinYIndex(Math.min(yIndexBegin,yIndexEnd));

            }


            wholeIndexOccupy.setOccupyPerXArrayList(occupyPerX,i);
        }
    }

    //输入x,得到y值



    public Index identifyIndex(Point point){

        Double pointX = point.getColX();
        Double pointY = point.getColY();

        //网格的起始x
        Double minX = xIndexCorList.get(0);

        //网格的起始y
        Double minY = yIndexCorList.get(0);
        Double xIndexTemp = (pointX - minX) / xGap;
        Double yIndexTemp = (pointY - minY) / yGap;




        Integer xIndex = xIndexTemp.intValue();
        Integer yIndex = yIndexTemp.intValue();



        Index index = new Index();

        if (xIndex == numOfGaps){

            xIndex = xIndex -1;

        }

        if (yIndex == numOfGaps){

            yIndex = yIndex -1;

        }



        index.setxIndex(xIndex);
        index.setyIndex(yIndex);

        return index;

    }

    public  Integer identifyYIndex(Double yCor){


        Double yMin = yIndexCorList.get(0);
        Double yIndexTemp = (yCor - yMin)/yGap;
        Integer yIndex = yIndexTemp.intValue();
        return yIndex;


    }

    public  Integer identifyXIndex(Double xCor){


//        Double xMin = xIndexCorList.get(0);
        Double xMin = xIndexCorList.get(0);
        Double xIndexTemp = (xCor - xMin)/xGap;
        Integer xIndex = xIndexTemp.intValue();

        if (xIndex >= numOfGaps){

            xIndex = numOfGaps - 1;

        }

        return xIndex;


    }











}
