package index.alg;

import index.entity.Point;
import index.entity.WholeIndex;

import java.util.ArrayList;

public class WorkPointsExclude {

    public ArrayList<Point> pointsExclude(ArrayList<Point> allWorkPoints, WholeIndex wholeIndex){

        ArrayList<Point> pointAfterExclude = new ArrayList<>();

        Double minX = wholeIndex.getMinX();
        Double minY = wholeIndex.getMinY();
        Integer numOfGapsX = wholeIndex.getNumOfGapsX();
        Integer numOfGapsY = wholeIndex.getNumOfGapsY();
        Double xGap =wholeIndex.getxGap();
        Double yGap = wholeIndex.getyGap();

        Double maxX = minX + numOfGapsX * xGap;
        Double maxY = minY + numOfGapsY * yGap;


        for(int i = 0 ; i < allWorkPoints.size();i++){
            Point point = allWorkPoints.get(i);
            Double corX = point.getColX();
            Double corY = point.getColY();
            if ( (corX < maxX) && (corX > minX) && (corY < maxY) && (corY > minY)){
                pointAfterExclude.add(point);
            }
        }

        return pointAfterExclude;

    }

}
