package index.alg.boxscan;

import index.entity.Box;
import index.entity.BoxEdge;
import index.entity.Point;
import index.log.Log;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.LinkedHashSet;

//输入网格，输出边（去重处理过后的）
public class GetAllEdge {

    public ArrayList<BoxEdge> cal(ArrayList<Box> allBusyBox){

        ArrayList<BoxEdge> boxEdges = new ArrayList<>();
        ArrayList<String> uidList = new ArrayList<>();

        //不包含重复边
        ArrayList<BoxEdge> boxEdgesWithOutDuplicates = new ArrayList<>();

        for (int i = 0 ; i < allBusyBox.size();i++){

            Box box = allBusyBox.get(i);//每个盒子里四条边
            boxEdges.addAll(box.getBoxEdgeArrayList());//

        }

        //为去重比较做准备，给每条边生成一个专属的字符串
        //把每条边的起点和终点做一下调整，相同的y值,x值小的在前，相同x值，y小的在前
        //比如（2，1），（1，1） 这条边生成的字符串就是1-1-1-2
        for (int i = 0 ; i < boxEdges.size();i++){

            BoxEdge boxEdge = boxEdges.get(i);
            ArrayList<Point> point12 = boxEdge.getPoint12();
            Point point1 = point12.get(0);
            Point point2 = point12.get(1);

            String edgeUid;
            if (point1.getColX().equals(point2.getColX())){

                if (point1.getColY() > point2.getColY()){

                    edgeUid = buildUid(point2,point1);

                }

                else {

                    edgeUid = buildUid(point1,point2);
                }

            }
            else if (point1.getColX() < point2.getColX()){

                edgeUid = buildUid(point1,point2);

            }
            else {

                edgeUid = buildUid(point2,point1);

            }
            uidList.add(edgeUid);
            }

        //
//        for (int i = 0 ; i < uidList.size();i++){
//
//            String uidTemp = uidList.get(i);
//            Log.print(uidTemp);

//        }
//        Log.print(" " + uidList.indexOf("97.0-71.0-98.0-71.0"));
//        Log.print(" " + uidList.lastIndexOf("97.0-71.0-98.0-71.0"));

//        Log.print(" " + uidList.get(35052));
//        Log.print(" " + uidList.get(35058));
//
//        Log.print(" " + uidList.size());

//        ArrayList<String> uidListCopy = uidList;
        ArrayList<String> uidListCopy = new ArrayList<>();
        //copy
        for (int i = 0 ; i < uidList.size();i++){

            uidListCopy.add(uidList.get(i));

        }





        for (int i = 0;i < uidList.size();i++){

            int frequency = Collections.frequency(uidListCopy,uidList.get(i));



            if (frequency == 1){

                boxEdgesWithOutDuplicates.add(boxEdges.get(i));

                uidListCopy.remove(uidList.get(i));

            }

            else {

//                System.out.println(uidList.get(i) + " " + frequency);

            }

        }



        return boxEdgesWithOutDuplicates;
    }

        public String buildUid(Point point1,Point point2){

            String uid = point1.getColX().toString() + "-" + point1.getColY().toString() + "-" + point2.getColX().toString() + "-" + point2.getColY();
            return uid;
        }
    }



