package index.alg.boxscan;

import com.sun.org.apache.bcel.internal.generic.NEW;
import index.entity.Box;
import index.entity.BoxEdge;
import index.entity.Point;
import index.log.Log;

import java.awt.*;
import java.util.ArrayList;


public class ScanOutLine {

    ArrayList<String> scanPriority = new ArrayList<>();
    Integer numOfGaps;
    ArrayList<ArrayList<BoxEdge>> shapeList = new ArrayList<>();
    ArrayList<ArrayList<Point>> shapePointList = new ArrayList<>();

    public ArrayList<ArrayList<BoxEdge>> getShapeList() {
        return shapeList;
    }

    public void setShapeList(ArrayList<ArrayList<BoxEdge>> shapeList) {
        this.shapeList = shapeList;
    }

    public ArrayList<ArrayList<Point>> getShapePointList() {
        return shapePointList;
    }

    public void setShapePointList(ArrayList<ArrayList<Point>> shapePointList) {
        this.shapePointList = shapePointList;
    }

    //设置扫描的优先级
    public ScanOutLine(ArrayList<String> ScanPriority){

        this.scanPriority = ScanPriority;

    }


    //设置默认的扫描的优先级
    public ScanOutLine(){

        scanPriority.add("UP");
        scanPriority.add("RIGHT");
        scanPriority.add("DOWN");
        scanPriority.add("LEFT");

    }

    //迭代
    public void scan(ArrayList<Box> allBusyBoxes,Integer numOfGaps) throws Exception{

        this.numOfGaps = numOfGaps;

        //获取所有的不重复的边
        GetAllEdge getAllEdge = new GetAllEdge();
        Log.print("网格数量：" + allBusyBoxes.size());
        ArrayList<BoxEdge> boxEdgeArrayList = getAllEdge.cal(allBusyBoxes);
        Log.print("形成的边总数为：" + boxEdgeArrayList.size());

        //随机挑选一个边，然后从边中挑选一个点

        //闭合轮廓list


        //挑边
        Integer randomBoxEdgeIndex = (int) (Math.random() * boxEdgeArrayList.size());
        Log.print("随机挑选第 " + randomBoxEdgeIndex + "条边");
        BoxEdge initialBoxEdge = boxEdgeArrayList.get(randomBoxEdgeIndex);


        Log.print("测试isEdgeEqual方法开始");

        judgeEdgeEqual1(initialBoxEdge,initialBoxEdge);

        Log.print("测试isEdgeEqual方法结束");

        //挑点，这里挑点1或者点2都可以
        Point pointInitial = initialBoxEdge.getPoint1();

        int scanCounter = 0;



        //某一个连通轮廓
        ArrayList<BoxEdge> shapeSingle = new ArrayList<>();

        //走过的点的list
        ArrayList<Point> shapePoint = new ArrayList<>();


        while (boxEdgeArrayList.size() !=0){

            Log.print("boxEdgeArrayList容量为： " + boxEdgeArrayList.size());

            scanCounter = scanCounter + 1;

            Log.print("第" + scanCounter + "次扫描");

            //某一个连通轮廓
//            ArrayList<BoxEdge> shapeSingle = new ArrayList<>();
//
            //走过的点的list
//            ArrayList<Point> shapePoint = new ArrayList<>();

            ArrayList<BoxEdge> matchBoxEdgeArrayList =new ArrayList<>();

            Point pointNext = new Point();

            //按方向去找下一个点
            for (int i = 0; i < scanPriority.size();i++) {

                String direction = scanPriority.get(i);

                Log.print("选择移动方向为： " + direction);

                Point pointNextTemp = genNextStep(pointInitial, direction);

                if (!isPointLegal(pointNextTemp, this.numOfGaps)) {

                    Log.print("沿 " + direction + " 方向没有可移动点");
                    continue;

                }

                BoxEdge boxEdgeBuild = new BoxEdge();

                //构造边
                boxEdgeBuild.setPoint1(pointInitial);
                boxEdgeBuild.setPoint2(pointNextTemp);

                //寻找和构造的边相等的边
                ArrayList<BoxEdge> matchBoxEdgeArrayListTemp = findEqualBoxEdgeFromList(boxEdgeBuild, boxEdgeArrayList);


                //如果找到了就跳出循环，不再从别的方向上去找下一步的点了
                if (matchBoxEdgeArrayListTemp.size() != 0){


                    Log.print("在boxEdgeArrayList中找到和构造边相等的边");
                    matchBoxEdgeArrayList = matchBoxEdgeArrayListTemp;
                    pointNext = pointNextTemp;

                    break;
                }
                else {

                    Log.print("沿" + direction + "方向未找到与构造边相等的边");
                }

            }
            //四个方向上找了一遍，都没有找到边
                if (matchBoxEdgeArrayList.size() == 0){
                    Log.print("未找到边！当前boxEdgeArrayList容量为 " + boxEdgeArrayList.size());
                    Log.print("将当前轮廓添加到list中，并继续计算其余连通区域");
                    shapeList.add(shapeSingle);
                    shapePointList.add(shapePoint);
                    Log.print("已添加当前轮廓");
                    shapeSingle = new ArrayList<>();
                    shapePoint = new ArrayList<>();
                    Log.print("已创建空的新轮廓");
                    Log.print("从剩下的边里产生产生一个初始点");
                    //从剩下的边里产生产生一个初始点
                    Integer randomBoxEdgeIndexNextCircle = (int) (Math.random() * boxEdgeArrayList.size());
                    BoxEdge initialBoxEdgeNextCircle = boxEdgeArrayList.get(randomBoxEdgeIndexNextCircle);
                    //挑点，这里挑点1或者点2都可以
                    pointInitial = initialBoxEdgeNextCircle.getPoint1();

                }

                else if (matchBoxEdgeArrayList.size() > 1){

                    throw new Exception("重复边未完全去除");

                }else {
                    //找到一条边，之后把连接的点存入一个list，并且把查到的那条边也存入一个数组

                    //把走过的点按顺序存入list
                    shapePoint.add(pointInitial);
                    //
                    BoxEdge boxEdgeFind = matchBoxEdgeArrayList.get(0);

                    //把走过的边按顺序存入list
                    shapeSingle.add(boxEdgeFind);

                    //这个需要检查一下看看是不是真的能够remove，如果不行就自己写一个remove方法

                    boxEdgeArrayList = removeBoxEdge(boxEdgeFind,boxEdgeArrayList);

                    if (boxEdgeArrayList.size() == 0){

                        Log.print("剩余边容量为0，保存当前轮廓");
                        shapeList.add(shapeSingle);
                        shapePointList.add(shapePoint);

                    }

                    pointInitial = pointNext;
                    Log.print("找到一条相连边");

                }
        }
    }

    public ArrayList<BoxEdge> removeBoxEdge(BoxEdge boxEdgeForRemove,ArrayList<BoxEdge> boxEdgeArrayList){

        ArrayList<BoxEdge> boxEdgeArrayList1 = new ArrayList<>();
        for (int i = 0 ; i < boxEdgeArrayList.size();i++){

            BoxEdge boxEdge = boxEdgeArrayList.get(i);
            if (!judgeEdgeEqual(boxEdgeForRemove,boxEdge)){

                boxEdgeArrayList1.add(boxEdge);

            }

        }
        return boxEdgeArrayList1;

    }


    public boolean judgePointEqual(Point point1,Point point2){

        boolean isEqual = false;

        if ((point1.getColX().equals(point2.getColX())) && (point1.getColY().equals(point2.getColY()))){


            isEqual = true;

        }

        return isEqual;

    }

    //获取下一个点
    public Point genNextStep(Point point,String direction){

        Point pointNext = new Point();

        if (direction.equals("UP")){

            pointNext.setColX(point.getColX());
            pointNext.setColY(point.getColY() + 1.0);

        }
        else if (direction.equals("DOWN")){

            pointNext.setColX(point.getColX());
            pointNext.setColY(point.getColY() - 1.0);

        }
        else if (direction.equals("LEFT")){

            pointNext.setColX(point.getColX() - 1);
            pointNext.setColY(point.getColY());

        }

        else {

            pointNext.setColX(point.getColX() + 1);
            pointNext.setColY(point.getColY());

        }

        return pointNext;

    }


    public boolean isPointLegal(Point point, Integer numOfGaps){

        boolean isLegal = true;
        double x = point.getColX();
        double y = point.getColY();
        if (x > numOfGaps || x < 0){

            isLegal = false;

        }

        if ( y > numOfGaps || y < 0){

            isLegal = false;

        }

        return isLegal;

    }

    public boolean judgeEdgeEqual(BoxEdge boxEdge1,BoxEdge boxEdge2){

//        Log.print("检查边是否相等");
        boolean isEdgeEqual = false;
        Point boxEdge1Point1 = boxEdge1.getPoint1();
//        Log.printPoint(boxEdge1Point1);
        Point boxEdge1Point2 = boxEdge1.getPoint2();
//        Log.printPoint(boxEdge1Point2);
        Point boxEdge2Point1 = boxEdge2.getPoint1();
//        Log.printPoint(boxEdge2Point1);
        Point boxEdge2Point2 = boxEdge2.getPoint2();
//        Log.printPoint(boxEdge2Point2);


        if (((judgePointEqual(boxEdge1Point1,boxEdge2Point1))&&(judgePointEqual(boxEdge1Point2,boxEdge2Point2))) ||((judgePointEqual(boxEdge1Point1,boxEdge2Point2))&&(judgePointEqual(boxEdge1Point2,boxEdge2Point1)))){

            isEdgeEqual = true;

        }

//        Log.print("检查结束,isEdgeEqual: " + isEdgeEqual);

        return isEdgeEqual;

    }

    public boolean judgeEdgeEqual1(BoxEdge boxEdge1,BoxEdge boxEdge2){

        Log.print("检查边是否相等");
        boolean isEdgeEqual = false;
        Point boxEdge1Point1 = boxEdge1.getPoint1();
        Log.printPoint(boxEdge1Point1);
        Point boxEdge1Point2 = boxEdge1.getPoint2();
        Log.printPoint(boxEdge1Point2);
        Point boxEdge2Point1 = boxEdge2.getPoint1();
        Log.printPoint(boxEdge2Point1);
        Point boxEdge2Point2 = boxEdge2.getPoint2();
        Log.printPoint(boxEdge2Point2);


        if (((judgePointEqual(boxEdge1Point1,boxEdge2Point1))&&(judgePointEqual(boxEdge1Point2,boxEdge2Point2))) ||((judgePointEqual(boxEdge1Point1,boxEdge2Point2))&&(judgePointEqual(boxEdge1Point2,boxEdge2Point1)))){

            isEdgeEqual = true;

        }

        Log.print("检查结束,isEdgeEqual: " + isEdgeEqual);

        return isEdgeEqual;

    }

    public ArrayList<BoxEdge> findEqualBoxEdgeFromList(BoxEdge boxEdge,ArrayList<BoxEdge> boxEdgeArrayList){
        ArrayList<BoxEdge> equalBoxEdgeArrayList = new ArrayList<>();
        for (int i = 0 ; i < boxEdgeArrayList.size();i++){
            BoxEdge boxEdge1 = boxEdgeArrayList.get(i);
            if (judgeEdgeEqual(boxEdge,boxEdge1)){
                equalBoxEdgeArrayList.add(boxEdge1);
            }
        }
        return equalBoxEdgeArrayList;
    }



}
