package index.file;

import index.entity.Point;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;


public class OperateFile {
    public ArrayList<String> readData(String filePath) throws FileNotFoundException {
        System.out.println("1");
        File file = new File(filePath);
        System.out.println(filePath);
        Scanner input = new Scanner(file);
        ArrayList<String> dataArrayList = new ArrayList<>();
        while (input.hasNext()){
            String rowData = input.nextLine();
            System.out.println(rowData);
            dataArrayList.add(rowData);
        }
        input.close();
        return dataArrayList;
    }
    public ArrayList<Map> readPoints(String filePath) throws FileNotFoundException {
        File file = new File(filePath);
        System.out.println(filePath);
        Scanner input = new Scanner(file);
        ArrayList<Map> dataArrayList = new ArrayList<>();
        while (input.hasNext()){
            String latStr = input.next();
            String lonStr = input.next();
            System.out.println(latStr);
            System.out.println(lonStr);
            Double lat = Double.parseDouble(latStr);
            Double lon = Double.parseDouble(lonStr);
            Map mapTemp = new HashMap();
            mapTemp.put("lat",lat);
            mapTemp.put("lon",lon);
            dataArrayList.add(mapTemp);
        }

        input.close();

        return dataArrayList;

    }

    public ArrayList<Point> readPointsFromFile(String filePath) throws FileNotFoundException {
        File file = new File(filePath);
        Scanner input = new Scanner(file);
        ArrayList<Point> dataArrayList = new ArrayList<>();
        while (input.hasNext()){
            Double x = input.nextDouble();
            Double y = input.nextDouble();
            Point point = new Point();
            point.setColX(x);
            point.setColY(y);
            dataArrayList.add(point);
        }
        input.close();
        return dataArrayList;

    }

    public ArrayList readFileStream(String filePath) throws FileNotFoundException {

        FileInputStream inputStream = new FileInputStream(filePath);

        ArrayList<String> dataArrayList = new ArrayList<>();

        Scanner sc = new Scanner(inputStream, "UTF-8");

        while (sc.hasNextLine()) {

            String line = sc.nextLine();
            dataArrayList.add(line);

        }

        return dataArrayList;
    }

    public void printData(String filePath,ArrayList<String> dataList) throws FileNotFoundException {

        File file = new File(filePath);

        java.io.PrintWriter listOutPut = new java.io.PrintWriter(file);

        for (int i = 0 ; i < dataList.size();i++){

            listOutPut.println(dataList.get(i).toString());

        }

        listOutPut.close();

    }

    public void printPoint(String filePath,ArrayList<Point> dataList) throws FileNotFoundException {

        File file = new File(filePath);

        java.io.PrintWriter listOutPut = new java.io.PrintWriter(file);

        for (int i = 0 ; i < dataList.size();i++){

            Point point = dataList.get(i);


            listOutPut.println(point.getColX() + " " + point.getColY());

        }

        listOutPut.close();

    }




}
